(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/platform-browser'), require('rxjs'), require('rxjs/operators'), require('ng-lazyload-image')) :
    typeof define === 'function' && define.amd ? define('ng-cloudimage-responsive', ['exports', '@angular/core', '@angular/common', '@angular/platform-browser', 'rxjs', 'rxjs/operators', 'ng-lazyload-image'], factory) :
    (global = global || self, factory(global['ng-cloudimage-responsive'] = {}, global.ng.core, global.ng.common, global.ng.platformBrowser, global.rxjs, global.rxjs.operators, global.ngLazyloadImage));
}(this, (function (exports, core, common, platformBrowser, rxjs, operators, ngLazyloadImage) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CIConfig = /** @class */ (function () {
        function CIConfig() {
        }
        return CIConfig;
    }());
    if (false) {
        /** @type {?} */
        CIConfig.prototype.token;
        /** @type {?} */
        CIConfig.prototype.container;
        /** @type {?} */
        CIConfig.prototype.ultraFast;
        /** @type {?} */
        CIConfig.prototype.lazyLoading;
        /** @type {?} */
        CIConfig.prototype.imgLoadingAnimation;
        /** @type {?} */
        CIConfig.prototype.lazyLoadOffset;
        /** @type {?} */
        CIConfig.prototype.width;
        /** @type {?} */
        CIConfig.prototype.height;
        /** @type {?} */
        CIConfig.prototype.operation;
        /** @type {?} */
        CIConfig.prototype.filters;
        /** @type {?} */
        CIConfig.prototype.placeholderBackground;
        /** @type {?} */
        CIConfig.prototype.baseUrl;
        /** @type {?} */
        CIConfig.prototype.presets;
        /** @type {?} */
        CIConfig.prototype.queryString;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CIService = /** @class */ (function () {
        function CIService(ciConfig) {
            this.config = {};
            var _a = ciConfig.token, token = _a === void 0 ? '' : _a, _b = ciConfig.container, container = _b === void 0 ? 'cloudimg.io' : _b, _c = ciConfig.ultraFast, ultraFast = _c === void 0 ? false : _c, _d = ciConfig.lazyLoading, lazyLoading = _d === void 0 ? true : _d, _e = ciConfig.imgLoadingAnimation, imgLoadingAnimation = _e === void 0 ? true : _e, _f = ciConfig.lazyLoadOffset, lazyLoadOffset = _f === void 0 ? 100 : _f, _g = ciConfig.width, width = _g === void 0 ? '400' : _g, _h = ciConfig.height, height = _h === void 0 ? '300' : _h, _j = ciConfig.operation, operation = _j === void 0 ? 'width' : _j, _k = ciConfig.filters, filters = _k === void 0 ? 'foil1' : _k, _l = ciConfig.placeholderBackground, placeholderBackground = _l === void 0 ? '#f4f4f4' : _l, _m = ciConfig.baseUrl, baseUrl = _m === void 0 ? '/' : _m, presets = ciConfig.presets, _o = ciConfig.queryString, queryString = _o === void 0 ? '' : _o;
            this.config = {
                token: token,
                container: container,
                ultraFast: ultraFast,
                lazyLoading: lazyLoading,
                imgLoadingAnimation: imgLoadingAnimation,
                lazyLoadOffset: lazyLoadOffset,
                width: width,
                height: height,
                operation: operation,
                filters: filters,
                placeholderBackground: placeholderBackground,
                baseUrl: baseUrl,
                presets: presets ? presets :
                    {
                        xs: '(max-width: 575px)',
                        // to 575       PHONE
                        sm: '(min-width: 576px)',
                        // 576 - 767    PHABLET
                        md: '(min-width: 768px)',
                        // 768 - 991    TABLET
                        lg: '(min-width: 992px)',
                        // 992 - 1199   SMALL_LAPTOP_SCREEN
                        xl: '(min-width: 1200px)' // from 1200    USUALSCREEN
                    },
                queryString: queryString,
                innerWidth: window.innerWidth,
                previewQualityFactor: 10
                // isChrome: /Chrome/.test(navigator.userAgent) && /Google Inc/.test(navigator.vendor)
            };
        }
        /**
         * @param {?} img
         * @param {?} config
         * @return {?}
         */
        CIService.prototype.getParentWidth = /**
         * @param {?} img
         * @param {?} config
         * @return {?}
         */
        function (img, config) {
            if (!(img && img.parentElement && img.parentElement.getBoundingClientRect) && !(img && img.width)) {
                return config.width;
            }
            /** @type {?} */
            var parentContainer = this.getParentContainerWithWidth(img);
            /** @type {?} */
            var currentWidth = parseInt('' + parentContainer, 10);
            /** @type {?} */
            var computedWidth = Number(window.getComputedStyle(img).width);
            if ((computedWidth && (computedWidth < currentWidth && computedWidth > 15) || !currentWidth)) {
                return this.getSizeLimit(computedWidth);
            }
            else {
                if (!currentWidth) {
                    return img.width || config.width;
                }
                return this.getSizeLimit(currentWidth);
            }
        };
        /**
         * @param {?} img
         * @return {?}
         */
        CIService.prototype.getParentContainerWithWidth = /**
         * @param {?} img
         * @return {?}
         */
        function (img) {
            /** @type {?} */
            var parentNode = null;
            /** @type {?} */
            var width = 0;
            do {
                parentNode = (parentNode && parentNode.parentNode) || img.parentNode;
                width = parentNode.getBoundingClientRect().width;
            } while (parentNode && !width);
            /** @type {?} */
            var letPadding = width && parentNode && parseInt(window.getComputedStyle(parentNode).paddingLeft, 10);
            /** @type {?} */
            var rightPadding = parseInt(window.getComputedStyle(parentNode).paddingRight, 10);
            return width + (width ? (-letPadding - rightPadding) : 0);
        };
        /**
         * @param {?} currentSize
         * @return {?}
         */
        CIService.prototype.getSizeLimit = /**
         * @param {?} currentSize
         * @return {?}
         */
        function (currentSize) {
            if (currentSize <= 25) {
                return '25';
            }
            if (currentSize <= 50) {
                return '50';
            }
            return (Math.ceil(currentSize / 100) * 100).toString();
        };
        /**
         * @param {?} size
         * @return {?}
         */
        CIService.prototype.checkOnMedia = /**
         * @param {?} size
         * @return {?}
         */
        function (size) {
            try {
                /** @type {?} */
                var array = size.split(',');
                return array.length > 1;
            }
            catch (e) {
                return false;
            }
        };
        /**
         * @param {?} src
         * @return {?}
         */
        CIService.prototype.checkIfRelativeUrlPath = /**
         * @param {?} src
         * @return {?}
         */
        function (src) {
            if (src.indexOf('//') === 0) {
                src = window.location.protocol + src;
            }
            return (src.indexOf('http://') !== 0 && src.indexOf('https://') !== 0 && src.indexOf('//') !== 0);
        };
        /**
         * @param {?} src
         * @param {?=} isRelativeUrlPath
         * @param {?=} baseUrl
         * @return {?}
         */
        CIService.prototype.getImgSrc = /**
         * @param {?} src
         * @param {?=} isRelativeUrlPath
         * @param {?=} baseUrl
         * @return {?}
         */
        function (src, isRelativeUrlPath, baseUrl) {
            if (isRelativeUrlPath === void 0) { isRelativeUrlPath = false; }
            if (baseUrl === void 0) { baseUrl = ''; }
            if (isRelativeUrlPath) {
                return baseUrl + src;
            }
            return src;
        };
        /**
         * @param {?} size
         * @return {?}
         */
        CIService.prototype.getSizeAccordingToPixelRatio = /**
         * @param {?} size
         * @return {?}
         */
        function (size) {
            /** @type {?} */
            var splittedSizes = size.toString().split('x');
            /** @type {?} */
            var result = [];
            [].forEach.call(splittedSizes, (/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                result.push(item * Math.round(window.devicePixelRatio || 1));
            }));
            return result.join('x');
        };
        /**
         * @param {?} operation
         * @param {?} size
         * @param {?} filters
         * @param {?} imgSrc
         * @param {?} config
         * @return {?}
         */
        CIService.prototype.generateUrl = /**
         * @param {?} operation
         * @param {?} size
         * @param {?} filters
         * @param {?} imgSrc
         * @param {?} config
         * @return {?}
         */
        function (operation, size, filters, imgSrc, config) {
            var ultraFast = config.ultraFast, token = config.token, container = config.container, queryString = config.queryString;
            /** @type {?} */
            var isUltraFast = ultraFast ? 'https://scaleflex.ultrafast.io/' : 'https://';
            /** @type {?} */
            var cloudUrl = isUltraFast + token + '.' + container + '/';
            return cloudUrl + operation + '/' + size + '/' + filters + '/' + imgSrc + queryString;
        };
        /**
         * @param {?} operation
         * @param {?} size
         * @param {?} filters
         * @param {?} imgSrc
         * @param {?} isAdaptive
         * @param {?} config
         * @param {?} isPreview
         * @return {?}
         */
        CIService.prototype.generateSources = /**
         * @param {?} operation
         * @param {?} size
         * @param {?} filters
         * @param {?} imgSrc
         * @param {?} isAdaptive
         * @param {?} config
         * @param {?} isPreview
         * @return {?}
         */
        function (operation, size, filters, imgSrc, isAdaptive, config, isPreview) {
            var _this = this;
            var previewQualityFactor = config.previewQualityFactor;
            /** @type {?} */
            var sources = [];
            if (isAdaptive) {
                size.forEach((/**
                 * @param {?} __0
                 * @return {?}
                 */
                function (_a) {
                    var nextSize = _a.size, mediaQuery = _a.media;
                    if (isPreview) {
                        nextSize = nextSize.split('x').map((/**
                         * @param {?} sizeNext
                         * @return {?}
                         */
                        function (sizeNext) { return Math.floor(sizeNext / previewQualityFactor); })).join('x');
                    }
                    sources.push({ mediaQuery: mediaQuery, srcSet: _this.generateSrcset(operation, nextSize, filters, imgSrc, config) });
                }));
            }
            else {
                if (isPreview) {
                    size = size.split('x').map((/**
                     * @param {?} sizeNext
                     * @return {?}
                     */
                    function (sizeNext) { return Math.floor(sizeNext / previewQualityFactor); })).join('x');
                }
                sources.push({
                    srcSet: this.generateSrcset(operation, size, filters, imgSrc, config)
                });
            }
            return sources;
        };
        /**
         * @param {?} size
         * @param {?} config
         * @return {?}
         */
        CIService.prototype.getAdaptiveSize = /**
         * @param {?} size
         * @param {?} config
         * @return {?}
         */
        function (size, config) {
            /** @type {?} */
            var arrayOfSizes = size.split(',');
            /** @type {?} */
            var sizes = [];
            arrayOfSizes.forEach((/**
             * @param {?} string
             * @return {?}
             */
            function (string) {
                /** @type {?} */
                var groups = string.match(/(([a-z_][a-z_]*)|(\([\S\s]*\)))\s*([0-9xp]*)/);
                /** @type {?} */
                var media = groups[3] ? groups[3] : config.presets[groups[2]];
                sizes.push({ media: media, size: groups[4] });
            }));
            return sizes;
        };
        /**
         * @param {?} operation
         * @param {?} size
         * @param {?} filters
         * @param {?} imgSrc
         * @param {?} config
         * @return {?}
         */
        CIService.prototype.generateSrcset = /**
         * @param {?} operation
         * @param {?} size
         * @param {?} filters
         * @param {?} imgSrc
         * @param {?} config
         * @return {?}
         */
        function (operation, size, filters, imgSrc, config) {
            var _a = __read(size.toString().split('x'), 2), imgWidth = _a[0], imgHeight = _a[1];
            return this.generateImgSrc(operation, filters, imgSrc, imgWidth, imgHeight, 1, config);
        };
        /**
         * @param {?} operation
         * @param {?} filters
         * @param {?} imgSrc
         * @param {?} imgWidth
         * @param {?} imgHeight
         * @param {?} factor
         * @param {?} config
         * @return {?}
         */
        CIService.prototype.generateImgSrc = /**
         * @param {?} operation
         * @param {?} filters
         * @param {?} imgSrc
         * @param {?} imgWidth
         * @param {?} imgHeight
         * @param {?} factor
         * @param {?} config
         * @return {?}
         */
        function (operation, filters, imgSrc, imgWidth, imgHeight, factor, config) {
            /** @type {?} */
            var imgSize = '' + Math.trunc(imgWidth * factor);
            if (imgHeight) {
                imgSize += 'x' + Math.trunc(imgHeight * factor);
            }
            return this.generateUrl(operation, this.getSizeAccordingToPixelRatio(imgSize), filters, imgSrc, config)
                .replace('http://scaleflex.ultrafast.io/', '')
                .replace('https://scaleflex.ultrafast.io/', '')
                .replace('//scaleflex.ultrafast.io/', '')
                .replace('///', '/');
        };
        /**
         * @param {?} size
         * @param {?} config
         * @return {?}
         */
        CIService.prototype.getRatioBySize = /**
         * @param {?} size
         * @param {?} config
         * @return {?}
         */
        function (size, config) {
            var _a, _b;
            /** @type {?} */
            var width;
            /** @type {?} */
            var height;
            if (typeof size === 'object') {
                /** @type {?} */
                var breakPointSource = this.getBreakPoint(size);
                /** @type {?} */
                var breakPointSize = breakPointSource ? breakPointSource.size : size[0].size;
                _a = __read(breakPointSize.toString().split('x'), 2), width = _a[0], height = _a[1];
            }
            else {
                _b = __read(size.toString().split('x'), 2), width = _b[0], height = _b[1];
            }
            if (width && height) {
                return width / height;
            }
            return null;
        };
        /**
         * @param {?} size
         * @return {?}
         */
        CIService.prototype.getBreakPoint = /**
         * @param {?} size
         * @return {?}
         */
        function (size) {
            return __spread(size).reverse().find((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return matchMedia(item.media).matches; }));
        };
        CIService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        CIService.ctorParameters = function () { return [
            { type: CIConfig }
        ]; };
        /** @nocollapse */ CIService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function CIService_Factory() { return new CIService(core.ɵɵinject(CIConfig)); }, token: CIService, providedIn: "root" });
        return CIService;
    }());
    if (false) {
        /** @type {?} */
        CIService.prototype.config;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ImgComponent = /** @class */ (function () {
        function ImgComponent(ciService, _sanitizer, cd, platformId) {
            this.ciService = ciService;
            this._sanitizer = _sanitizer;
            this.cd = cd;
            this.platformId = platformId;
            this.class = '';
            this.offset = 100;
            this.lazyLoading = null;
            this.emptyOnSsr = false;
            this.imageLoaded = new core.EventEmitter();
            this.cloudimageUrl = '';
            this.sources = [];
            this.firstSource = null;
            this.restSources = [];
            this.isLoaded = false;
            this.isProcessed = false;
            this.windowInnerWidth = window.innerWidth;
            this.isSsr = common.isPlatformServer(platformId);
        }
        Object.defineProperty(ImgComponent.prototype, "isLazyLoadingMode", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.isSsr) {
                    return false;
                }
                if (typeof this.lazyLoading === 'boolean') {
                    return this.lazyLoading;
                }
                return this.ciService.config.lazyLoading || false;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ImgComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.resizeSubscription$.unsubscribe();
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.resizeObservable$ = rxjs.fromEvent(window, 'resize').pipe(operators.debounceTime(500));
            this.resizeSubscription$ = this.resizeObservable$.subscribe((/**
             * @return {?}
             */
            function () {
                if (_this.isAdaptive || _this.windowInnerWidth < window.innerWidth) {
                    _this.processImage();
                }
                _this.windowInnerWidth = window.innerWidth;
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        ImgComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            /** @type {?} */
            var srcChanged = changes.src && changes.src.previousValue !== changes.src.currentValue && !changes.src.firstChange;
            /** @type {?} */
            var ratioChanged = changes.ratio && changes.ratio.previousValue !== changes.ratio.currentValue && !changes.ratio.firstChange;
            if (srcChanged || ratioChanged) {
                this.processImage();
            }
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            this.processImage();
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.processImage = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var imgNode = (this.imgElem || this.pictureElem).nativeElement;
            var _a = this.ciService.config, config = _a === void 0 ? {} : _a;
            var previewQualityFactor = config.previewQualityFactor;
            /** @type {?} */
            var operation = this.operation || this.o || config.operation;
            /** @type {?} */
            var parentContainerWidth = this.ciService.getParentWidth(imgNode, config);
            /** @type {?} */
            var size = this.size || this.s || config.size || parentContainerWidth;
            /** @type {?} */
            var filters = this.filters || this.f || config.filters;
            /** @type {?} */
            var isAdaptive = this.ciService.checkOnMedia(size);
            size = isAdaptive ? this.ciService.getAdaptiveSize(size, config) : size;
            /** @type {?} */
            var isRelativeUrlPath = this.ciService.checkIfRelativeUrlPath(this.src);
            /** @type {?} */
            var imgSrc = this.ciService.getImgSrc(this.src, isRelativeUrlPath, config.baseUrl);
            /** @type {?} */
            var resultSize = isAdaptive ? size : this.ciService.getSizeAccordingToPixelRatio(size);
            this.isPreview = !config.isChrome && (parentContainerWidth > 400) && this.isLazyLoadingMode;
            this.cloudimageUrl = isAdaptive ?
                this.ciService.generateUrl('width', this.ciService.getSizeAccordingToPixelRatio(parentContainerWidth), filters, imgSrc, config) :
                this.ciService.generateUrl(operation, resultSize, filters, imgSrc, config);
            this.sources = isAdaptive ?
                this.ciService.generateSources(operation, resultSize, filters, imgSrc, isAdaptive, config, false) : [];
            /** @type {?} */
            var previewCloudimageUrl;
            /** @type {?} */
            var previewSources;
            if (this.isPreview) {
                /** @type {?} */
                var previewConfig = __assign({}, config, { queryString: '' });
                previewCloudimageUrl = isAdaptive ?
                    this.ciService.generateUrl('width', (Math.floor(parentContainerWidth / previewQualityFactor)), filters, imgSrc, previewConfig) :
                    this.ciService.generateUrl(operation, resultSize.split('x').map((/**
                     * @param {?} item
                     * @return {?}
                     */
                    function (item) { return Math.floor(item / previewQualityFactor); })).join('x'), filters, imgSrc, previewConfig);
                previewSources = isAdaptive ?
                    this.ciService.generateSources(operation, resultSize, filters, imgSrc, isAdaptive, previewConfig, true) : [];
            }
            this.previewCloudimageUrl = previewCloudimageUrl;
            this.previewSources = previewSources;
            this.isAdaptive = isAdaptive;
            this.actualSize = size;
            this.parentContainerWidth = parentContainerWidth;
            /** @type {?} */
            var ratioBySize = this.ciService.getRatioBySize(size, config);
            this.imageHeight = Math.floor(parentContainerWidth / (ratioBySize || this.ratio || 1.5));
            this.isRatio = !!(ratioBySize || this.ratio);
            this.ratioBySize = ratioBySize;
            this.isProcessed = true;
            this.cd.detectChanges();
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        ImgComponent.prototype.onImageLoad = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if (!this.isPreview) {
                this.isPreviewLoaded = true;
                this.isLoaded = true;
            }
            else if (this.isPreviewLoaded) {
                this.isLoaded = true;
            }
            else {
                this.isPreviewLoaded = true;
            }
            this.imageLoaded.emit($event);
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getRestSources = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var resultSources = __spread((!this.isPreview ? this.sources : (this.isPreviewLoaded ? this.sources : this.previewSources)));
            return resultSources.slice(1).reverse();
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getFirstSource = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var resultSources = __spread((!this.isPreview ? this.sources : (this.isPreviewLoaded ? this.sources : this.previewSources)));
            this.firstSource = resultSources[0];
            return resultSources[0];
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getPositionStyle = /**
         * @return {?}
         */
        function () {
            return this._sanitizer.bypassSecurityTrustStyle(this.isRatio ? 'absolute' : 'relative');
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getImgHeight = /**
         * @return {?}
         */
        function () {
            // todo check if we need 100% height
            // return this._sanitizer.bypassSecurityTrustStyle(this.isRatio ? '100%' : 'auto');
            return this._sanitizer.bypassSecurityTrustStyle(this.isRatio ? 'auto' : 'auto');
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getTransformStyle = /**
         * @return {?}
         */
        function () {
            var config = this.ciService.config;
            /** @type {?} */
            var result = 'none';
            if (config.imgLoadingAnimation) {
                result = 'scale3d(1.1, 1.1, 1)';
            }
            if (this.isLoaded && config.imgLoadingAnimation) {
                result = 'translateZ(0) scale3d(1, 1, 1)';
            }
            return this._sanitizer.bypassSecurityTrustStyle(result);
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getTransitionStyle = /**
         * @return {?}
         */
        function () {
            var config = this.ciService.config;
            /** @type {?} */
            var result = 'none';
            if (this.isLoaded && config.imgLoadingAnimation) {
                result = 'all 0.3s ease-in-out';
            }
            return this._sanitizer.bypassSecurityTrustStyle(result);
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getFilterStyle = /**
         * @return {?}
         */
        function () {
            var config = this.ciService.config;
            /** @type {?} */
            var result = 'none';
            if (config.imgLoadingAnimation) {
                result = "blur(" + Math.floor(parseInt(this.parentContainerWidth, 10) / 100) + "px)";
            }
            if (this.isLoaded && config.imgLoadingAnimation) {
                result = 'blur(0px)';
            }
            return this._sanitizer.bypassSecurityTrustStyle(result);
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getPicturePaddingBottom = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var result = '';
            if (this.isRatio) {
                result = (100 / (this.ratioBySize || this.ratio)) + '%';
            }
            return this._sanitizer.bypassSecurityTrustStyle(result);
        };
        /**
         * @return {?}
         */
        ImgComponent.prototype.getPictureBackground = /**
         * @return {?}
         */
        function () {
            var config = this.ciService.config;
            /** @type {?} */
            var result = 'transparent';
            if (this.isRatio && !this.isPreviewLoaded && !this.isLoaded) {
                result = config.placeholderBackground;
            }
            return this._sanitizer.bypassSecurityTrustStyle(result);
        };
        ImgComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ci-img',
                        template: "<picture *ngIf=\"!isProcessed\" #pictureElem></picture>\n\n<ng-container *ngIf=\"isProcessed\">\n  <picture\n    [class]=\"class + ' cloudimage-image-picture cloudimage-image-' + (isLoaded ? 'loaded' : 'loading')\"\n    style=\"display:block;width:100%;overflow:hidden;position:relative;\"\n    [style.paddingBottom]=\"getPicturePaddingBottom()\"\n    [style.background]=\"getPictureBackground()\"\n    #imgElem\n    *ngIf=\"isProcessed\"\n  >\n    <ng-container *ngIf=\"isLazyLoadingMode; then lazyLoadingTpl else notLazyLoadingTpl\"></ng-container>\n  </picture>\n</ng-container>\n\n<ng-template #lazyLoadingTpl>\n  <source\n    *ngFor=\"let source of getRestSources()\"\n    [media]=\"source.mediaQuery || ''\"\n    [attr.lazyLoad]=\"source.srcSet || ''\"\n    (load)=\"onImageLoad($event)\"\n  />\n  <source\n    *ngIf=\"getFirstSource()\"\n    [attr.lazyLoad]=\"firstSource.srcSet || ''\"\n    (load)=\"onImageLoad($event)\"\n  />\n  <img\n    style=\"display:block;width:100%;opacity:1;top:0;left:0;\"\n    [style.position]=\"getPositionStyle()\"\n    [style.height]=\"getImgHeight()\"\n    [style.paddingBottom]=\"getPicturePaddingBottom()\"\n    [style.transform]=\"getTransformStyle()\"\n    [style.transition]=\"getTransitionStyle()\"\n    [style.filter]=\"getFilterStyle()\"\n    (load)=\"onImageLoad($event)\"\n    [lazyLoad]=\"!isPreview || isPreviewLoaded ? cloudimageUrl : previewCloudimageUrl\"\n    [offset]=\"offset\"\n    [attr.alt]=\"alt\"\n  />\n</ng-template>\n\n<ng-template #notLazyLoadingTpl>\n  <source\n    *ngFor=\"let source of restSources\"\n    [media]=\"source.mediaQuery || ''\"\n    [srcset]=\"source.srcSet || ''\"\n    (load)=\"onImageLoad($event)\"\n  />\n  <source\n    *ngIf=\"firstSource\"\n    [srcset]=\"firstSource.srcSet || ''\"\n    (load)=\"onImageLoad($event)\"\n  />\n  <img\n    *ngIf=\"!(isSsr && emptyOnSsr)\"\n    style=\"display:block;width:100%;opacity:1;top:0;left:0;\"\n    [style.position]=\"getPositionStyle()\"\n    [style.height]=\"getImgHeight()\"\n    [style.transform]=\"getTransformStyle()\"\n    [style.transition]=\"getTransitionStyle()\"\n    [style.filter]=\"getFilterStyle()\"\n    (load)=\"onImageLoad($event)\"\n    [src]=\"!isPreview || isPreviewLoaded ? cloudimageUrl : previewCloudimageUrl\"\n    [attr.alt]=\"alt\"\n  />\n</ng-template>\n"
                    }] }
        ];
        /** @nocollapse */
        ImgComponent.ctorParameters = function () { return [
            { type: CIService },
            { type: platformBrowser.DomSanitizer },
            { type: core.ChangeDetectorRef },
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] }
        ]; };
        ImgComponent.propDecorators = {
            imgElem: [{ type: core.ViewChild, args: ['imgElem', { static: false },] }],
            pictureElem: [{ type: core.ViewChild, args: ['pictureElem', { static: false },] }],
            src: [{ type: core.Input }],
            class: [{ type: core.Input }],
            alt: [{ type: core.Input }],
            operation: [{ type: core.Input }],
            o: [{ type: core.Input }],
            size: [{ type: core.Input }],
            s: [{ type: core.Input }],
            filters: [{ type: core.Input }],
            f: [{ type: core.Input }],
            ratio: [{ type: core.Input }],
            offset: [{ type: core.Input }],
            ngSwitch: [{ type: core.Input }],
            lazyLoading: [{ type: core.Input }],
            emptyOnSsr: [{ type: core.Input }],
            imageLoaded: [{ type: core.Output }]
        };
        return ImgComponent;
    }());
    if (false) {
        /** @type {?} */
        ImgComponent.prototype.imgElem;
        /** @type {?} */
        ImgComponent.prototype.pictureElem;
        /** @type {?} */
        ImgComponent.prototype.src;
        /** @type {?} */
        ImgComponent.prototype.class;
        /** @type {?} */
        ImgComponent.prototype.alt;
        /** @type {?} */
        ImgComponent.prototype.operation;
        /** @type {?} */
        ImgComponent.prototype.o;
        /** @type {?} */
        ImgComponent.prototype.size;
        /** @type {?} */
        ImgComponent.prototype.s;
        /** @type {?} */
        ImgComponent.prototype.filters;
        /** @type {?} */
        ImgComponent.prototype.f;
        /** @type {?} */
        ImgComponent.prototype.ratio;
        /** @type {?} */
        ImgComponent.prototype.offset;
        /** @type {?} */
        ImgComponent.prototype.ngSwitch;
        /** @type {?} */
        ImgComponent.prototype.lazyLoading;
        /** @type {?} */
        ImgComponent.prototype.emptyOnSsr;
        /** @type {?} */
        ImgComponent.prototype.imageLoaded;
        /** @type {?} */
        ImgComponent.prototype.resizeObservable$;
        /** @type {?} */
        ImgComponent.prototype.resizeSubscription$;
        /** @type {?} */
        ImgComponent.prototype.cloudimageUrl;
        /** @type {?} */
        ImgComponent.prototype.sources;
        /** @type {?} */
        ImgComponent.prototype.firstSource;
        /** @type {?} */
        ImgComponent.prototype.restSources;
        /** @type {?} */
        ImgComponent.prototype.isLoaded;
        /** @type {?} */
        ImgComponent.prototype.isProcessed;
        /** @type {?} */
        ImgComponent.prototype.isPreview;
        /** @type {?} */
        ImgComponent.prototype.previewCloudimageUrl;
        /** @type {?} */
        ImgComponent.prototype.previewSources;
        /** @type {?} */
        ImgComponent.prototype.isAdaptive;
        /** @type {?} */
        ImgComponent.prototype.actualSize;
        /** @type {?} */
        ImgComponent.prototype.parentContainerWidth;
        /** @type {?} */
        ImgComponent.prototype.isPreviewLoaded;
        /** @type {?} */
        ImgComponent.prototype.isRatio;
        /** @type {?} */
        ImgComponent.prototype.ratioBySize;
        /** @type {?} */
        ImgComponent.prototype.imageHeight;
        /** @type {?} */
        ImgComponent.prototype.windowInnerWidth;
        /** @type {?} */
        ImgComponent.prototype.isSsr;
        /**
         * @type {?}
         * @private
         */
        ImgComponent.prototype.ciService;
        /**
         * @type {?}
         * @private
         */
        ImgComponent.prototype._sanitizer;
        /**
         * @type {?}
         * @private
         */
        ImgComponent.prototype.cd;
        /**
         * @type {?}
         * @private
         */
        ImgComponent.prototype.platformId;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CIModule = /** @class */ (function () {
        function CIModule() {
        }
        CIModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [ImgComponent],
                        imports: [common.CommonModule, ngLazyloadImage.LazyLoadImageModule],
                        exports: [ImgComponent],
                        providers: []
                    },] }
        ];
        return CIModule;
    }());

    exports.CIConfig = CIConfig;
    exports.CIModule = CIModule;
    exports.CIService = CIService;
    exports.ImgComponent = ImgComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-cloudimage-responsive.umd.js.map
